/*
Title:			m168lissajous.c
Author:			Windell Oskay  http://www.evilmadscientist.com/
Date Created:   8/4/08
Copyright 2008 Windell H. Oskay
Distributed under the terms of the GNU General Public License, please see below.


Purpose: Draw sine wave; for hand-held lissajous figures.

This code should be relatively straigtforward, so not much documentation is provided.  If you'd like to ask 
questions, suggest improvements, or report success, please use the evilmadscientist forum:
http://www.evilmadscientist.com/forum/
 

Fusing notes:
We will want to run with the 8 MHz internal RC oscillator,
and with the clock prescaler turned off (divide by 1)


 This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


*/



#include <avr/io.h>  
 
#include <math.h>

#define delaytime 6000U



void delay()
{
unsigned int delayvar;
	delayvar = 0; 
	while (delayvar <=  delaytime)		
		{ 
			asm("nop");  
			delayvar++;
		}
}

 


int main (void)
{   

unsigned short i,j,k;	//Dummy
float floattime; 
 unsigned short shortpos; 
float position;
float twopi = 2*M_PI;

unsigned short sinetable[100];

unsigned short time = 0; 
 
 

time = 0;

PORTD = 0;
PORTC = 0;
PORTB = 0;

DDRD = 255;		//Port D: All outputs
DDRC = 255;
DDRB = 255;

//Fill Sine Table:

k = 0;
while (k < 100)
{
PORTD = k;

floattime = 0.01*k*twopi;
position = 6.00 + 5.99*sin(floattime);

i = 0;
j = 1;

if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j++)
	i++;
if (position > j)
	i++;
			
sinetable[k]=i;
k++;

}

PORTD = 0;







for (;;)  // main loop										
{

 delay();
 
time++;

if (time > 99)
	time = 0;
	 
shortpos = sinetable[time];

	
switch ( shortpos ) {
case 0:
	PORTB = 0;
	PORTC = 32;
	PORTD = 0;
	break;
case 1:
	PORTB = 0;
	PORTC = 0;
	PORTD = 1;
	break;
case 2:
  	PORTB = 0;
	PORTC = 0;
	PORTD = 2;
	break;
case 3:
  	PORTB = 0;
	PORTC = 0;
	PORTD = 4;
	break;
case 4:
  	PORTB = 0;
	PORTC = 0;
	PORTD = 8;
	break;
case 5:
  	PORTB = 0;
	PORTC = 0;
	PORTD = 16;
	break;  
case 6:
  	PORTB = 64;
	PORTC = 0;
	PORTD = 0;
	break;
case 7:
	PORTB = 128;
	PORTC = 0;
	PORTD = 0;
	break;
case 8:
	PORTB = 0;
	PORTC = 0;
	PORTD = 32;
	break;
case 9:
	PORTB = 0;
	PORTC = 0;
	PORTD = 64;
	break;
case 10:
	PORTB = 0;
	PORTC = 0;
	PORTD = 128;
	break;
case 11:
	PORTB = 1;
	PORTC = 0;
	PORTD = 0;
	break;    
default:
  break;
}	
	

}	//End main loop.
	return 0;
}
